
package tests.HelloWidget;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.Timer;
import java.util.TimerTask;

import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.widget.RemoteViews;
import android.widget.Toast;

public class HelloWidget extends AppWidgetProvider {
	int quantitimer = 0;

	@Override
	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
		quantitimer = quantitimer +1;
		Toast.makeText(context,"OnUpdate! "+quantitimer,Toast.LENGTH_LONG).show();
		Timer timer = new Timer();
		timer.scheduleAtFixedRate(new MyTime(context, appWidgetManager), 100, 1000);
	}
	
	private class MyTime extends TimerTask {
			RemoteViews remoteViews;
			AppWidgetManager appWidgetManager;
			ComponentName thisWidget;
			DateFormat format = SimpleDateFormat.getTimeInstance(SimpleDateFormat.MEDIUM,Locale.getDefault());
			
		public MyTime(Context context, AppWidgetManager appWidgetManager) {
			this.appWidgetManager = appWidgetManager;
			remoteViews = new RemoteViews(context.getPackageName(), R.layout.main);
			thisWidget = new ComponentName(context, HelloWidget.class);
			Toast.makeText(context,"Nuovo Timer!",Toast.LENGTH_LONG).show();
		}
			
		@Override
		public void run() {
				remoteViews.setTextViewText(R.id.widget_textview,"Time = " + format.format(new Date()));
				appWidgetManager.updateAppWidget(thisWidget, remoteViews);
		}
	}
	
	@Override
	public void onReceive(Context context, Intent intent) {
	// v1.5 fix that doesn't call onDelete Action
	final String action = intent.getAction();
	if (AppWidgetManager.ACTION_APPWIDGET_DELETED.equals(action)) {
	final int appWidgetId = intent.getExtras().getInt(
	AppWidgetManager.EXTRA_APPWIDGET_ID,
	AppWidgetManager.INVALID_APPWIDGET_ID);
	if (appWidgetId != AppWidgetManager.INVALID_APPWIDGET_ID) {
	this.onDeleted(context, new int[] { appWidgetId });
	}
	} else {
	super.onReceive(context, intent);
	}
	}
	
}
